<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOriginDestinationCalendarResult ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOriginDestinationCalendarResult
 * @subpackage Arrays
 */
class ArrayOfOriginDestinationCalendarResult extends AbstractStructArrayBase
{
    /**
     * The OriginDestinationCalendarResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OriginDestinationCalendarResult[]
     */
    public $OriginDestinationCalendarResult;
    /**
     * Constructor method for ArrayOfOriginDestinationCalendarResult
     * @uses ArrayOfOriginDestinationCalendarResult::setOriginDestinationCalendarResult()
     * @param \App|C\StructType\OriginDestinationCalendarResult[] $originDestinationCalendarResult
     */
    public function __construct(array $originDestinationCalendarResult = array())
    {
        $this
            ->setOriginDestinationCalendarResult($originDestinationCalendarResult);
    }
    /**
     * Get OriginDestinationCalendarResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OriginDestinationCalendarResult[]|null
     */
    public function getOriginDestinationCalendarResult()
    {
        return isset($this->OriginDestinationCalendarResult) ? $this->OriginDestinationCalendarResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOriginDestinationCalendarResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOriginDestinationCalendarResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginDestinationCalendarResultForArrayConstraintsFromSetOriginDestinationCalendarResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOriginDestinationCalendarResultOriginDestinationCalendarResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfOriginDestinationCalendarResultOriginDestinationCalendarResultItem instanceof \App|C\StructType\OriginDestinationCalendarResult) {
                $invalidValues[] = is_object($arrayOfOriginDestinationCalendarResultOriginDestinationCalendarResultItem) ? get_class($arrayOfOriginDestinationCalendarResultOriginDestinationCalendarResultItem) : sprintf('%s(%s)', gettype($arrayOfOriginDestinationCalendarResultOriginDestinationCalendarResultItem), var_export($arrayOfOriginDestinationCalendarResultOriginDestinationCalendarResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OriginDestinationCalendarResult property can only contain items of type \App|C\StructType\OriginDestinationCalendarResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OriginDestinationCalendarResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationCalendarResult[] $originDestinationCalendarResult
     * @return \App|C\ArrayType\ArrayOfOriginDestinationCalendarResult
     */
    public function setOriginDestinationCalendarResult(array $originDestinationCalendarResult = array())
    {
        // validation for constraint: array
        if ('' !== ($originDestinationCalendarResultArrayErrorMessage = self::validateOriginDestinationCalendarResultForArrayConstraintsFromSetOriginDestinationCalendarResult($originDestinationCalendarResult))) {
            throw new \InvalidArgumentException($originDestinationCalendarResultArrayErrorMessage, __LINE__);
        }
        if (is_null($originDestinationCalendarResult) || (is_array($originDestinationCalendarResult) && empty($originDestinationCalendarResult))) {
            unset($this->OriginDestinationCalendarResult);
        } else {
            $this->OriginDestinationCalendarResult = $originDestinationCalendarResult;
        }
        return $this;
    }
    /**
     * Add item to OriginDestinationCalendarResult value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationCalendarResult $item
     * @return \App|C\ArrayType\ArrayOfOriginDestinationCalendarResult
     */
    public function addToOriginDestinationCalendarResult(\App|C\StructType\OriginDestinationCalendarResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\OriginDestinationCalendarResult) {
            throw new \InvalidArgumentException(sprintf('The OriginDestinationCalendarResult property can only contain items of type \App|C\StructType\OriginDestinationCalendarResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OriginDestinationCalendarResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\OriginDestinationCalendarResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\OriginDestinationCalendarResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\OriginDestinationCalendarResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\OriginDestinationCalendarResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\OriginDestinationCalendarResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OriginDestinationCalendarResult
     */
    public function getAttributeName()
    {
        return 'OriginDestinationCalendarResult';
    }
}
