<?php

namespace App|C\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Send ServiceType
 * @subpackage Services
 */
class Send extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SendTicketConfirmation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \App|C\StructType\SendTicketConfirmation $parameters
     * @return \App|C\StructType\SendTicketConfirmationResponse|bool
     */
    public function SendTicketConfirmation(\App|C\StructType\SendTicketConfirmation $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SendTicketConfirmation($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \App|C\StructType\SendTicketConfirmationResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
