<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CancelInfo
 * @subpackage Structs
 */
class CancelInfo extends AbstractStructBase
{
    /**
     * The CanCancel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $CanCancel;
    /**
     * The CanRefund
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $CanRefund;
    /**
     * The CanRequestRefund
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $CanRequestRefund;
    /**
     * The CanVoid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $CanVoid;
    /**
     * Constructor method for CancelInfo
     * @uses CancelInfo::setCanCancel()
     * @uses CancelInfo::setCanRefund()
     * @uses CancelInfo::setCanRequestRefund()
     * @uses CancelInfo::setCanVoid()
     * @param bool $canCancel
     * @param bool $canRefund
     * @param bool $canRequestRefund
     * @param bool $canVoid
     */
    public function __construct($canCancel = null, $canRefund = null, $canRequestRefund = null, $canVoid = null)
    {
        $this
            ->setCanCancel($canCancel)
            ->setCanRefund($canRefund)
            ->setCanRequestRefund($canRequestRefund)
            ->setCanVoid($canVoid);
    }
    /**
     * Get CanCancel value
     * @return bool|null
     */
    public function getCanCancel()
    {
        return $this->CanCancel;
    }
    /**
     * Set CanCancel value
     * @param bool $canCancel
     * @return \App|C\StructType\CancelInfo
     */
    public function setCanCancel($canCancel = null)
    {
        // validation for constraint: boolean
        if (!is_null($canCancel) && !is_bool($canCancel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($canCancel, true), gettype($canCancel)), __LINE__);
        }
        $this->CanCancel = $canCancel;
        return $this;
    }
    /**
     * Get CanRefund value
     * @return bool|null
     */
    public function getCanRefund()
    {
        return $this->CanRefund;
    }
    /**
     * Set CanRefund value
     * @param bool $canRefund
     * @return \App|C\StructType\CancelInfo
     */
    public function setCanRefund($canRefund = null)
    {
        // validation for constraint: boolean
        if (!is_null($canRefund) && !is_bool($canRefund)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($canRefund, true), gettype($canRefund)), __LINE__);
        }
        $this->CanRefund = $canRefund;
        return $this;
    }
    /**
     * Get CanRequestRefund value
     * @return bool|null
     */
    public function getCanRequestRefund()
    {
        return $this->CanRequestRefund;
    }
    /**
     * Set CanRequestRefund value
     * @param bool $canRequestRefund
     * @return \App|C\StructType\CancelInfo
     */
    public function setCanRequestRefund($canRequestRefund = null)
    {
        // validation for constraint: boolean
        if (!is_null($canRequestRefund) && !is_bool($canRequestRefund)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($canRequestRefund, true), gettype($canRequestRefund)), __LINE__);
        }
        $this->CanRequestRefund = $canRequestRefund;
        return $this;
    }
    /**
     * Get CanVoid value
     * @return bool|null
     */
    public function getCanVoid()
    {
        return $this->CanVoid;
    }
    /**
     * Set CanVoid value
     * @param bool $canVoid
     * @return \App|C\StructType\CancelInfo
     */
    public function setCanVoid($canVoid = null)
    {
        // validation for constraint: boolean
        if (!is_null($canVoid) && !is_bool($canVoid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($canVoid, true), gettype($canVoid)), __LINE__);
        }
        $this->CanVoid = $canVoid;
        return $this;
    }
}
